//
//  bidwatcher
//  copyright (c) 1999 2000
//  Trent McNair (trent@rmci.net)
//  Tom McNair  (tmcnair@cyberhighway.net)
//  Wayne Schlitt (wayne@midwestcs.com)
// 
//  helpers.cpp:
//
//  Helper functions for bidwatcher, no platform/gui specific
//  code.
// 

#include "qtbidwatcher.h"
char *CheckPrice="0123456789.$, ";      // Characters allowed in a price   

char *SearchOps[2][23]={{ "Starts at",		        // 1:  +1
                          "Currently",		        // 2:  +1
                          "First bid",        		// 3:  +1
                          "Quantity",          		// 4:  +1
                          "# of bids",          	// 5:  +1   
                          "Time left",          	// 6:  +1
                          "Location",           	// 7:  +1
                          "Started",            	// 8:  +1
                          "Ends",               	// 9:  +1
                          "Seller (Rating)",    	// 10: +1
                          "High bid",           	// 11: +1
                          "Bid increment",      	// 12: +1
                          "This is a ",         	// 13: +1
                          "Lowest",             	// 14: +1
			"Price",                	// 15: +1
			"Buy It Now",           	// 16: +1 
			"High bidder used Buy It Now! ",// 17: +1
			"(reserve not yet met)",	// 18: +1
			"Current bid",			// 19 +1
			"Starting bid",			// 20 +1
			"Seller (rating)",		// 21 +1
			"High bidder",			// 22 +1
                          "*"},				// 23: Default
                        /* eBay Motors */
                        { "Currently",
                          "Time left ",
                          "Seller (rating) ",
                          "High bid ",
                          "# of bids ",
                          "Location ",
                          "Started ",
                          "ends ",
                          "Starts at",
			  "Current bid",
			  "Ends ",
			  "Starting bid",
			  "High bidder ",
                          "*"
                        }
};
void calculateBidIncrement(const char * currentBid, char * newBid, char * currency)
{

	int len,err;
	// step 1 - parse currentBid into useable int's
	char curBid[15];
	if ( currentBid[0] == '$' )
	{
	strcpy(currency,"$");
		int limit = strlen(currentBid);
		for ( int i=0; i < limit; i++ )
		{
			// strip the '$' off the currentBid;
			curBid[i] = currentBid[i + 1];
		}
		curBid[14] = '\0'; // because I'm insane
	}
	else
	{
    strncpy(currency,currentBid,6);  
    currency[6]='\0';
    len=strcspn(currency," ");
    currency[len]='\0';
    len=strcspn(currentBid,"0123456789");
    currentBid+=len; // skip to price
    strcpy(curBid,currentBid);
	}
	float fcb = atof(curBid);   // fcb = 'float current bid'
	float inc;
          // it's official! :)


        switch(currency[0]) {
        case '$': // all three types of dollars have the same increments
          // it's official! :)
        case 'U': // US dollar
        case 'A': // australian dollars
        case 'C': // canadian dollars
          if (fcb < 1.00) inc = 0.05;
          else if (fcb < 5.00) inc = 0.25;
          else if (fcb < 25.00) inc = 0.50;
          else if (fcb < 100.00) inc = 1.00;
          else if (fcb < 250.00) inc = 2.50;
          else if (fcb < 500.00) inc = 5.00;
          else if (fcb < 1000.00) inc = 10.00;
          else if (fcb < 2500.00) inc = 25.00;
          else if (fcb < 5000.00) inc = 50.00;
          else inc = 100.00;
          break;
        case 'G': // great british pounds
          inc=100;
          if (fcb<3000) inc=50;
          if (fcb<1500) inc=20;
          if (fcb<600) inc=10;
          if (fcb<300)  inc=5;
          if (fcb<150) inc=2; 
          if (fcb<60) inc=1;   
          if (fcb<15) inc=0.50;
          if (fcb<5.00) inc=0.20;
          if (fcb<1) inc=0.05;
          break;
        case 'J': // japanese yen
          inc=12000;
          if (fcb<=600000) inc=7500;
          if (fcb<=300000) inc=3000;
          if (fcb<=120000) inc=1200;
          if (fcb<=60000)  inc=600;
          if (fcb<=30000) inc=240;
          if (fcb<=12000) inc=120;
          if (fcb<=3000) inc=60;
          if (fcb<=600) inc=30;
          if (fcb<=120) inc=5;
          break;
        case 'D':  // deutsche marks (german)
          inc=100;
          if (fcb<10000) inc=10;
          if (fcb<1000) inc=5;
          if (fcb<100) inc=1;  
          break;
        default:
          inc=0;
        }

	fcb = fcb + inc;
	err = sprintf(newBid, "%f", fcb);
	// now, truncate the end:
	unsigned int j = 0;
	while ( newBid[j] != '.' )
	{
		j++;
		if ( j > strlen(newBid) ) break;
	}
	j+=3;
	newBid[j] = '\0';
	return;
}

char translate_special(const char *input, int *len) {
  // Does translation of special characters in HTML
  // of the format &XXXX;
        
  char temp[11];
  char temp2[11];
  memset(temp, 0, sizeof(temp));
  memset(temp2, 0, sizeof(temp2));

   ifstream inFile;
   char * homedir = getenv("HOME"); 
   char fileName[200];
   strcpy(fileName, homedir);
   strcat(fileName, "/.bidwatcher/special.cfg");
               
   inFile.open(fileName, ios::in);
               
   if ( inFile )
   {
      while ( inFile )
      {
	inFile.getline(temp2, 11, '\n');
	*len = strstr(input, ";") - input - 1;
	if (*len < 10) {                 // Is this reasonable?
	strncpy(temp, input+1, *len);
		(*len)++;                      // So we erase everything later
	if (strcmp(temp, temp2) == 0)
	return ' ';
	  }

	 }
	}
	else {
	inFile.close();
	return 0;   
	}
	if ( strlen(temp) > 0 ) printf("Got unknown char (%s)\n", temp);
	inFile.close();
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
// StripHtmlTags()
//    -strips the tags off an html string
///////////////////////////////////////////////////////////////////////////////
void StripHtmlTags(const char * stringToStrip, char * Buff, int BuffSize) {
  
   strcpy(Buff, "");
   int buffLength = strlen(stringToStrip);
   int BuffIdx = 0;
   int u,c;


  int IncludeFlag = 5; // strip up everything before the first tag, too
  // strip the html tags
  for (u = 0; u < buffLength; u++) {
    c = stringToStrip[u];
    if (c == '<') IncludeFlag=5;
    else if (c == '>') IncludeFlag=10;
    else if (IncludeFlag==10) {
      if ((BuffIdx > 0) && (c == ' ') &&
          (Buff[BuffIdx-1] != ' ') && (Buff[BuffIdx-1] != '\n')) {
        Buff[BuffIdx++] = ' ';
      } 
      else if ((BuffIdx > 0) && (c == '\n') &&
                 (Buff[BuffIdx-1] != '\n')) {
        Buff[BuffIdx++] = c;
      } 
      else if (c == '&') {
        int charlen = 0;
        // Try to find the end of the char sequence &XXX;
        if (strstr(&stringToStrip[u], ";") != NULL)
          Buff[BuffIdx] = translate_special(&stringToStrip[u], &charlen);

        if (Buff[BuffIdx] != 0)
          u += charlen;

        // If it was 0, we didn't know what it was, proceed as normal.
        if (Buff[BuffIdx] == 0)
          Buff[BuffIdx] = c;

        BuffIdx++;
	}
	else if ((c > 31) && (c < 127)) Buff[BuffIdx++] = c;

	else if ((Buff[BuffIdx-1]=='\n') && (Buff[BuffIdx-2]=='\n')) BuffIdx--;
        //printf("c[%i]=%c\n", c, c);
      else if (c == -96)
        Buff[BuffIdx++] = ' '; // Weird non-space character.
      else if ((c > -96) && (c < 0)) {
        Buff[BuffIdx++] = c;
        //printf("c[%i]=%c\n", c, c);
      }

    }
  }
  Buff[BuffIdx - 1] = '\0';
  return;
}

//////////////////////////////////////////////////////////////////////
//  StripAndTab - strips html tags off an html buffer and inserts
//     tabs where each tag goes, this aids in parsing later
//////////////////////////////////////////////////////////////////////

void StripAndTab(const char * stringToStrip, char * Buff, int BuffSize)
{
   strcpy(Buff, "");
   int buffLength = strlen(stringToStrip);
   int BuffIdx = 0;
   int u,c;
   int IncludeFlag = 5;
   bool tabFlag = FALSE;

  for (u = 0; (u < buffLength);u++) {
    c = stringToStrip[u];
    if (c=='<') {
      tabFlag = FALSE;
      IncludeFlag=5;
    }
    else if (c=='>') {
      tabFlag = TRUE;
      IncludeFlag=10;
    }
    else if (IncludeFlag==10) {
      if (tabFlag) {
        Buff[BuffIdx++] = '\t';
        tabFlag = FALSE;
      }
      if (((c>31) && (c<127)) || (c=='\n')) Buff[BuffIdx++]=c;
    }
  }
  Buff[BuffIdx - 1] = '\0';
}
	    
void strip_commas( char *p )
{
   int i, j, len;

   len = strlen( p );
   for( i = 0, j = 0; i <= len; i++ )
       if( p[ i ] != ',' )
	   p[j++] = p[i];
   p[j] = '\0';

}


void parseprice(char *b,char *CurrentBid, char *currency) {
  int len;
  if ((b[0]=='$') || (b[0]=='U' && b[1]=='S')) strcpy(currency,"$");
  else {
    strncpy(currency,b,6);
    currency[6]='\0';
    len=strcspn(currency," ");
    currency[len]='\0';
  }
  len=strcspn(b,"0123456789");
  b+=len; // skip to price
  len=strspn(b,"0123456789.,");
  b[len]='\0';
  strip_commas(b);
  strcpy(CurrentBid,b);
}

void parsebid(char *b,char *CurrentBid) {
  int len;
  len=strcspn(b,"0123456789$");
  b+=len; // skip to price
  len=strspn(b,"0123456789.,$");
  b[len]='\0';
  strip_commas(b);   
  strcpy(CurrentBid,b);
}

void strip_space( char *p )
{

    int in_q = 0;
    int i, c, c1=0;
    i = strlen(p);
    while (c1 < i) {                     /* remove spaces */
        if (p[c1] == '\'' || p[c1] == '"')
          in_q = !in_q;
        if ((p[c1] == ' ') && (!in_q))
          for (c=c1; c<i; c++) p[c] = p[c+1];
        else
          c1++;
    }
}
	    
//////////////////////////////////////////////////////////////////////////////////
// ProcessBidSubmission
//    takes the html response from submitting a bid and returns an appropriate
//    error code.
// return values:
//    1 - bid submission was a success - we are the high bidder
//    2 - Bid too low
//    3 - Quantity Problem
//    4 - Other problem (unknown, probably bad connection)
//   
//////////////////////////////////////////////////////////////////////////////////
int ProcessBidSubmission( char * Buff, char * lineBuff )
{
        istrstream streamBuff(Buff);
        bool foundKey = FALSE;
        bool foundAffirmation = FALSE;

        while ( streamBuff ) {
                streamBuff.getline(lineBuff, 1024, '\n');
		if (strstr(lineBuff, "name=\"key\"") != NULL) {
			if (foundKey = TRUE) return 1;
                        if (foundAffirmation) return 1;
                }
		else if (strstr(lineBuff, "Confirm that your bid is correct"))
                {
                        foundAffirmation = TRUE;
                        if (foundKey) return 1;
                }
                else if (strstr(lineBuff, "Problem with bid amount") != NULL)
                  return 2;
                else if (strstr(lineBuff, "Problem with quantity") != NULL)
                  return 3;
                else if (strstr(lineBuff, "Cannot proceed") != NULL)
                  return 5;
        }
        return 4;
}
//////////////////////////////////////////////////////////////////////////////////
// ProcessBid()
//    takes the html response from making a bid
// return values:
//    1 - bid submission was a success - we are the high bidder
//    2 - bid successful, but we were outbid.
//    3 - bid under the current asking price
//    4 - problem with the bid quantity
//    5 - Auction is over.
//    6 - invalid username / password.
//    7 - unknown error
//   
//////////////////////////////////////////////////////////////////////////////////
int ProcessBid( char * Buff )
{
	char lineBuff[1024];
   istrstream streamBuff(Buff);


	while ( streamBuff ) {
		streamBuff.getline(lineBuff, 1024, '\n');
		if ( strstr(lineBuff, "are the current high bidder") != NULL ) return 1;
		else if ( strstr(lineBuff, "one of the high bidders in this Dutch Auction") != NULL ) return 1;
		else if ( strstr(lineBuff, "<b>We're sorry") !=NULL )  return 2;
		else if ( strstr(lineBuff, "outbid you") != NULL ) return 2;
		else if ( strstr(lineBuff, "You have been outbid") != NULL ) return 2;
		else if ( strstr(lineBuff, "Problem with quantity") != NULL ) return 4;
		else if ( strstr(lineBuff, "Cannot proceed") != NULL ) return 5;
		else if ( strstr(lineBuff, "or password invalid") != NULL ) return 6;
	}
	return 7;


}
///////////////////////////////////////////////////////////////////////////////
// ParseList
//   parses auction information from the listings or bidders list pages.
///////////////////////////////////////////////////////////////////////////////
int ParseList( BidMakeup_type * TempList, char * Buff)
{
   char lineBuff[2048];
   int cnt;
   int cnt2;
   istrstream streamBuff(Buff);
   int listCount = 0;

   while( streamBuff )

{
      streamBuff.getline(lineBuff, 2048, '\n');
      if ( (lineBuff[0]=='\t') && (isdigit(lineBuff[1])) && (isdigit(lineBuff[2])) && 
           (isdigit(lineBuff[3])) && (isdigit(lineBuff[4])) ) {
         cnt2 = 1;
         cnt=0;
         if ( strstr(lineBuff,"Hidden") == NULL )
         {
            char * scratch;
            scratch = strtok(lineBuff, "\t");

            if ( !scratch ) return listCount;
            strcpy(TempList[listCount].ItemNumber, scratch);

	      streamBuff.getline(lineBuff, 2048, '\n');
		streamBuff.getline(lineBuff, 2048, '\n');
		scratch = strtok(lineBuff, "\t");

            strcpy(TempList[listCount].Ends, scratch);


            scratch = strtok(0, "\t");
              streamBuff.getline(lineBuff, 2048, '\n');
                scratch = strtok(lineBuff, "\t");
            if ( !scratch ) return listCount;
            strcpy(TempList[listCount].CurrentBid, scratch);
	    strip_commas( TempList[listCount].CurrentBid );

         streamBuff.getline(lineBuff, 2048, '\n');
         if ( strlen(lineBuff) < 2 ) streamBuff.getline(lineBuff, 2048, '\n');
	  scratch = strtok(lineBuff,"\t");

            strcpy(TempList[listCount].Description, scratch);

         streamBuff.getline(lineBuff, 2048, '\n');
         scratch = strtok(lineBuff,"\t");
            strcpy(TempList[listCount].HighBidder, scratch);


            listCount++;
            if (listCount >= (MAXAUCS - 1)) break;
         }
      }
   }
   return listCount;
}
//////////////////////////////////////////////////////////////////////////////
// CheckBadChars
// aids GetAucInfo in parsing html correctly
//////////////////////////////////////////////////////////////////////////////
void CheckBadChars(char *Str2Chk, char *GoodChars) {

  int idx,idx2;

  for (idx=0;Str2Chk[idx]!=0;++idx) {

    for (idx2=0;GoodChars[idx2]!=0;++idx2) {
      if (GoodChars[idx2]==Str2Chk[idx]) break; 
    }

    if (GoodChars[idx2]==0) { 
      Str2Chk[idx]=0; 
      return;
    }
  }
}

//////////////////////////////////////////////////////////////////////////////
// ReturnBidVarNum
//////////////////////////////////////////////////////////////////////////////
int ReturnBidVarNum(char *LineData, int auc_type)
{
  int idx=0;

  for(idx=0;SearchOps[auc_type][idx][0]!='*';++idx) 
    if (strcmp(LineData,SearchOps[auc_type][idx])==0) {
      return (idx+1);
    }

  return 0;

}
//////////////////////////////////////////////////////////////////////////////
// ClearBidMakeUp:
// Clears the information in a BidMakeup struct
//////////////////////////////////////////////////////////////////////////////
void ClearBidMakeUp(struct BidMakeup_type & NewAuction) 
{
  NewAuction.ItemNumber[0]=0;
  NewAuction.Description[0]=0;
  NewAuction.CurrentBid[0]=0;
  NewAuction.FirstBid[0]=0;
  NewAuction.Quantity[0]=0;
  NewAuction.BidCount[0]=0;
  NewAuction.TimeLeft[0]=0;
  NewAuction.Location[0]=0;
  NewAuction.Started[0]=0;
  NewAuction.Ends[0]=0;
  NewAuction.Seller[0]=0;
  NewAuction.HighBidder[0]=0;
  NewAuction.BidInc[0]=0;
  NewAuction.SellerRate[0] = 0;
  NewAuction.BidderRate[0] = 0;
  NewAuction.snipeAmount[0] = 0;
  NewAuction.snipeQty[0] = 0;
  NewAuction.snipeKey[0] = 0;
  NewAuction.stat = '0';
  NewAuction.reserveMet = '0';
  NewAuction.isSnipe = FALSE;
  NewAuction.EndsValue = 0;
  NewAuction.auc_type_save = 0;
  NewAuction.BuyitNowPrice[0]=0;
}
//////////////////////////////////////////////////////////////////////////////
// CalcEndsValue
//
// takes ebay format ending time (i.e. xx/xx/xx, xx:xx:xx) and converts
// it to time in seconds since a epoch (jan 1, 1970), this is for easy
// sorting later.
//
//////////////////////////////////////////////////////////////////////////////
long int CalcEndsValue( char * Ends )
{
   if ( strlen(Ends) > 12 )
   {
      //  convert Ends into in values of year, month,  day
      char tokEnds[50]; // the tokenized Ends, will be tossed.
      strncpy(tokEnds, Ends, 50);
      tokEnds[49] = '\0'; 
      char * scratch;
      int seconds,minutes,hours,month,day,year;
      scratch = strtok(tokEnds, "/");
      if ( scratch )  month = atoi(scratch);
      else return -1;
      scratch = strtok(0,"/");
      if ( scratch )  day = atoi(scratch);
      else return -1;
      scratch = strtok(0," ");
      if ( scratch )  year = atoi(scratch);
      else return -1;
      scratch = strtok(0,":");
      if ( scratch ) hours = atoi(scratch);
      else return -1;
      scratch = strtok(0,":");
      if ( scratch )  minutes = atoi(scratch);
      else return -1;
      scratch = strtok(0," \0");
      if ( scratch )  seconds = atoi(scratch);
      else return -1;
      if ( year < 25 ) year = year + 100;

      struct tm TheTime;
      TheTime.tm_sec = seconds;
      TheTime.tm_min = minutes;
      TheTime.tm_hour = hours;
      TheTime.tm_mday = day;
      TheTime.tm_mon = month - 1;
      TheTime.tm_year = year;
      TheTime.tm_yday = 0;
      TheTime.tm_wday = 0;
      TheTime.tm_isdst = -1;
         
      // now we have day,month,year,minutes,hours,seconds in integer format,
      // we just need to convert it to seconds since the epoch and we're in
      // business.
      long int the_time = mktime(&TheTime);
      return the_time;
   }
   else return -1; 
}
//////////////////////////////////////////////////////////////////////////////
//   CalcTimeLeft
//       calculates the time left in an auction in seconds.
//   stringTimeLeft
//       calculates the time left and return a string of that value
//////////////////////////////////////////////////////////////////////////////
long int CalcTimeLeft ( long int endTime, int ebayOffset )
{
   long int localTime = time(NULL);
   localTime += ebayOffset;
   return (endTime - localTime);
}
int stringTimeLeft ( long int endTime, int ebayOffset, char * chTimeLeft )
{
   long int localTime = time(NULL);
   localTime += ebayOffset;
   int intTimeLeft = (endTime - localTime);
   int err;
   if ( intTimeLeft >= 172800 ) {
      err = sprintf(chTimeLeft, "%d days, %d hrs", intTimeLeft / 86400,
                        (intTimeLeft % 86400) / 3600 );
		return intTimeLeft;
   }
   else if ( intTimeLeft >= 86400 ) {
      err = sprintf(chTimeLeft, "%d day, %d hrs", intTimeLeft / 86400,
                        (intTimeLeft % 86400) / 3600 );
		return intTimeLeft;
   }
   else if ( intTimeLeft >= 3600 ) {
      err = sprintf(chTimeLeft, "%d hrs, %d mins", intTimeLeft / 3600,
                        (intTimeLeft % 3600) / 60);
		return intTimeLeft;
   }
   else if ( intTimeLeft >= 60 ) {
      err = sprintf(chTimeLeft, "%d mins, %d secs", intTimeLeft / 60,
                        intTimeLeft % 60);
		return intTimeLeft;
   }
   else if ( intTimeLeft >= 0 ) {
      err = sprintf(chTimeLeft, "%d seconds", intTimeLeft );
      return intTimeLeft;
   }
   else {
      err = sprintf(chTimeLeft, "Auction Ended" );
      return intTimeLeft;
   }
}     
//////////////////////////////////////////////////////////////////////////////
//   translate_date
//       converts dates from "Jan-23-00 12:34:56" into "01/23/00, 12:34:56"
//////////////////////////////////////////////////////////////////////////////
void translate_date( char *date )
{
    int		i;
    char	*months[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
			      "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };

    if( isdigit( *date ) )
	return;

    for( i = 0; i < 12; i++ )
    {
	if( strncasecmp( date, months[ i ], 3 ) == 0 )
	    break;
    }

    if( i >= 12 )
	return;

    if( date[ 3 ] != '-' || date[ 6 ] != '-' || date[ 9 ] != ' ' )
	return;

    sprintf( date, "%02d", i+1 );
    date[ 2 ] = '/';
    date[ 3 ] = date[ 4 ];
    date[ 4 ] = date[ 5 ];
    date[ 5 ] = '/';
    date[ 6 ] = date[ 7 ];
    date[ 7 ] = date[ 8 ];
    date[ 8 ] = ',';

}
//////////////////////////////////////////////////////////////////////////////
//   GetAucInfo
//       loads up BidMakeup[] with auction info.
//////////////////////////////////////////////////////////////////////////////
bool GetAucInfo(char *Buff, struct BidMakeup_type & NewAuction)
{
   int idx=0;
   int cnt, rows, dataID, timeDiff2=0;
   int ended_early=0;
   int auc_type=TYPE_EBAY;
   char LineData[2049];
   char * scratch;
   char newName[76];
   char fileName[200];
   char authID[76];
   char CurrentBid[15];
   char currency[10];
   char BuyitNowPrice[15];
   bool earlycheck;

   ifstream inFile;
   char * homedir = getenv("HOME");
   strcpy(fileName, homedir);
   strcat(fileName, "/.bidwatcher/bw.cfg");
 
   inFile.open(fileName, ios::in);
 
   if ( inFile )
   {
      inFile >> dataID;
      while ( inFile )
      {
         switch (dataID)
         {

            case 1:
               inFile >> rows; inFile >> rows; inFile >> rows; inFile >> rows;
               inFile >> rows; inFile >> rows; inFile >> rows; inFile >> rows;
               inFile >> timeDiff2;
               inFile >> earlycheck;
		inFile >> rows; inFile >> rows; inFile >> rows;
               inFile.ignore(200,'\n');
		inFile >> dataID;
               inFile.ignore();
               inFile.getline(authID, 76, '\n');
               break;
	default:
		inFile.close();
		break;
	  }
		inFile.close();
	 }
		inFile.close();
	}

   // First Lets clear out the right bits of the structure
   memset( NewAuction.CurrentBid, 0, sizeof( NewAuction.CurrentBid ) );
   memset( NewAuction.FirstBid, 0, sizeof( NewAuction.FirstBid ) );
   memset( NewAuction.Quantity, 0, sizeof( NewAuction.Quantity ) );
   memset( NewAuction.BidCount, 0, sizeof( NewAuction.BidCount ) );
   memset( NewAuction.TimeLeft, 0, sizeof( NewAuction.TimeLeft ) );
   memset( NewAuction.Location, 0, sizeof( NewAuction.Location ) );
   memset( NewAuction.Started, 0, sizeof( NewAuction.Started ) );
   memset( NewAuction.Ends, 0, sizeof( NewAuction.Ends ) );
   memset( NewAuction.Seller, 0, sizeof( NewAuction.Seller ) );
   memset( NewAuction.HighBidder, 0, sizeof( NewAuction.HighBidder ) );
   memset( NewAuction.BuyitNowPrice, 0, sizeof( NewAuction.BuyitNowPrice ) );
   NewAuction.reserveMet = 'x';
   NewAuction.BuyitNow = 'n';
   /*
    * Parse the description out of the buffer first. This is
    * most easily done at the buffer-level and not as we try
    * to read the buffer in a line-oriented manner. There is
    * probably a need to re-write this parser all together,
    * but that's not what I'm going to do right now.
    * Thanks to Bob Beaty!
    */
   scratch = strstr(Buff, ") -");
   if (scratch != NULL) {
     // move past the ") -"
     scratch += 3;
     // move past any whitespace
     while (isspace(*scratch)) scratch++;
     // copy over the description to a newline
     idx = 0;
     while (*scratch != '\n') {
       NewAuction.Description[idx++] = *scratch++;
     }
     // NULL terminate the description I just parsed off
     NewAuction.Description[idx] = '\0';
   } else {
     return FALSE;
   }
   istrstream streamBuff(Buff);
   while(strstr(LineData,"eBay")==NULL && streamBuff)
     streamBuff.getline(LineData, 1024, '\n');

   if ( strstr(LineData,"eBay item") == NULL ) auc_type = TYPE_EBAYMOTORS;
   if (strstr(LineData,"eBay Motors item") != NULL) auc_type = TYPE_EBAYMOTORSCAR;
   while(strstr(LineData,") -")==NULL && streamBuff)
     streamBuff.getline(LineData, 1024, '\n');

	if ( strstr(LineData,"The seller ended this listing early") == NULL ){
	scratch = strstr(Buff, "The seller ended this listing early");
	if (scratch != NULL) NewAuction.endedNow = 1;
	}
   if ( strstr(LineData,"Buy It Now") == NULL ){
      scratch = strstr(Buff, "Buy It Now for");
      if (scratch != NULL) {
      scratch = strstr(Buff, "Auction has ended with Buy It Now.");   
      if (scratch != NULL) {
        NewAuction.BuyitNow = 'n';
        ended_early = 1;
        }
        else
        {
        NewAuction.BuyitNow = 'y';
        }
         }
        }
  if (auc_type == TYPE_EBAYMOTORSCAR ) {
	NewAuction.auc_type_save = 1;
	scratch = strstr(Buff, "Current bid");
	if (scratch != NULL) {
     scratch = strstr(Buff, "Starting bid");
     if (scratch != NULL) {
       // This is totally crazy and will break as soon as they muck with
       // the html but it works for now to distinguish a Car auction from
       // a part or accessory.  Anyone want to offer a better suggestion?
  
       //Should move us ahead to a $.  This check is here to make sure
       //we aren't looking at something the seller said in his desc etc.
    
	if (scratch[16] == '$' ) auc_type = TYPE_EBAYMOTORS;
   }
 }
 }
   while (streamBuff) 
   {
      streamBuff.getline(LineData, 2048, '\n');

    
      // The Idea here is to get the info we can get, if for
      // some reason some of the data is missing or out of
      // order we can still salvage what we can..
      if (LineData[0]!=0) 
      {
        switch (auc_type) {
        case 0 :
         switch (ReturnBidVarNum(LineData, auc_type)) 
         {
        case 1 : 
	case 19:
	case 15:
        case 14: // "Lowest" -shows up on motorsnotcars
        case 2 : if (NewAuction.CurrentBid[0]==0) {
		streamBuff.getline(LineData, 1024, '\n');
                if (strstr(LineData, "Buy It Now") != NULL){
                streamBuff.getline(LineData, 1024, '\n');
                streamBuff.getline(LineData, 1024, '\n');
                strcpy(NewAuction.BidCount, "0");
                parseprice(LineData,CurrentBid,currency);
                strcpy(NewAuction.BuyitNowPrice,currency);
                strncat(NewAuction.BuyitNowPrice,CurrentBid,14);   
		strncpy(NewAuction.HighBidder,"--",2);
                        }
		   parseprice(LineData,CurrentBid,currency);
		   strcpy(NewAuction.CurrentBid,currency);
                   strncat(NewAuction.CurrentBid,CurrentBid,14);
		   strcpy(NewAuction.currency,currency);
		streamBuff.getline(LineData, 1024, '\n');

                if (strstr(LineData, "First bid") != NULL) {
                  for (unsigned int i=0; i<=strlen(LineData); i++)
                    streamBuff.unget();
                }
                 }
                 break;

	case 20 :
        case 3 : if (NewAuction.FirstBid[0]==0) {
                  streamBuff.getline(LineData, 1024, '\n');
		  parseprice(LineData,CurrentBid,currency);
		   strcpy(NewAuction.FirstBid,currency);
                   strncat(NewAuction.FirstBid,CurrentBid,14);
                 }
                 break;

        case 4 : if (NewAuction.Quantity[0]==0) {
                   streamBuff.getline(LineData, 1024, '\n');
                   CheckBadChars(LineData,"0123456789");
                   strncpy(NewAuction.Quantity,LineData,14);
		if (LineData[0] > '1' || (LineData[0] >= '1' && LineData[1] >= '0')) {
                 strcpy(NewAuction.HighBidder, "Dutch Auction");
                 break;
		}
                 }
                 break;

        case 5 : if (NewAuction.BidCount[0]==0) {
                   streamBuff.getline(LineData, 1024, '\n');
   for(cnt=0;(((LineData[cnt]!=' ') && (LineData[cnt]!=0)) && (cnt<14));++cnt)
                     NewAuction.BidCount[cnt]=LineData[cnt];
                   NewAuction.BidCount[cnt]=0;
                 }
                 break;

        case 6 : if (NewAuction.TimeLeft[0]==0) {
                   streamBuff.getline(LineData, 1024, '\n');
                   strncpy(NewAuction.TimeLeft,LineData,50);
            if (strstr(LineData, "Auction has ended") != NULL ) { //DBS
		int minTimeLeft2;
		minTimeLeft2  = CalcTimeLeft(NewAuction.EndsValue, timeDiff2 );
		if (minTimeLeft2 > 0) {
               ended_early = 1;                                    //DBS
		}
		 }
                  }
                 break;

        case 7 : if (NewAuction.Location[0]==0) {
                  streamBuff.getline(LineData, 1024, '\n');
                   strncpy(NewAuction.Location,LineData,100);
                 }
                 break;

        case 8 : if (NewAuction.Started[0]==0) {
                   streamBuff.getline(LineData, 1024, '\n');
                   strncpy(NewAuction.Started,LineData,50);
		   translate_date( NewAuction.Started );
                 }
                 break;

        case 9 : if (NewAuction.Ends[0]==0) {
                   streamBuff.getline(LineData, 1024, '\n');
                   strncpy(NewAuction.Ends,LineData,50);
		   translate_date( NewAuction.Ends );
                 }
                 break;

	case 21 :
        case 10 : if (NewAuction.Seller[0]==0) {
                  streamBuff.getline(LineData, 1024, '\n');
                   strncpy(NewAuction.Seller,LineData,75);
                 }
                 break;

	case 22:
        case 11: if (NewAuction.HighBidder[0]==0) {
                   streamBuff.getline(LineData, 1024, '\n');
                   strncpy(NewAuction.HighBidder,LineData,76);
                   NewAuction.HighBidder[75] = '\0';
                 }
                 break;
        case 17:
        case 16: if (NewAuction.BuyitNowPrice[0]==0) {
                   streamBuff.getline(LineData, 1024, '\n');
		scratch = strstr(LineData, "for");
		if ( scratch  != NULL) streamBuff.getline(LineData, 1024, '\n');
                scratch = strstr(LineData, "Learn more"); 
                if ( scratch != NULL) {
                strcpy(NewAuction.BuyitNowPrice,"Sold! BuyitNow");
                }
                else
                {
                   parseprice(LineData,BuyitNowPrice,currency);
                   strcpy(NewAuction.BuyitNowPrice,currency);
                   strncat(NewAuction.BuyitNowPrice,BuyitNowPrice,14);
                }
                 }
                 break;

	case 18:
              if ( strstr(LineData,"reserve not") != NULL)
                      NewAuction.reserveMet = 'n';

		break;
        default:;
      }
	break;
          /* End case 0 of auc_type */
       case 1:
          switch(ReturnBidVarNum(LineData, auc_type )) {
          case 1:  // Current Bid
	  case 9:
	  case 10:
	  case 12:
            if (NewAuction.CurrentBid[0]==0) {
              streamBuff.getline(LineData, 1024, '\n');
	      parseprice(LineData,CurrentBid,currency);
		strcpy(NewAuction.CurrentBid,currency);
		strncat(NewAuction.CurrentBid,CurrentBid,14);

		streamBuff.getline(LineData, 1024, '\n');
		streamBuff.getline(LineData, 1024, '\n');
              if ( strstr(LineData,"reserve not") != NULL )
                NewAuction.reserveMet = 'n';
              else if ( strstr(LineData,"reserve met") != NULL )
                NewAuction.reserveMet = 'y';
                else
                  // Not a reserve auction, put the chars back.
                  for (unsigned int i=0; i<=strlen(LineData); i++)
                    streamBuff.unget();
            }
            break;
            

          case 2: //Time left
              if (NewAuction.TimeLeft[0]==0) {
	if ( strstr(LineData,"Time left") == NULL ) streamBuff.getline(LineData, 1024, '\n');
                   strncpy(NewAuction.TimeLeft,LineData,50);
            if (strstr(LineData, "Auction has ended") != NULL ) { //DBS
		int minTimeLeft2;
                minTimeLeft2  = CalcTimeLeft(NewAuction.EndsValue, -7200);
                if (minTimeLeft2 > 0) {
               ended_early = 1;                                    //DBS
                }}

              }
            break;
          case 3: //Seller
              if (NewAuction.Seller[0]==0) {
                streamBuff.getline(LineData, 1024, '\n'); 
		strncpy(NewAuction.Seller,LineData,75);
              }
            break;
	  case 13:
          case 4: //High bid
              if (NewAuction.HighBidder[0]==0) {
                streamBuff.getline(LineData, 1024, '\n');
                   strncpy(NewAuction.HighBidder,LineData,76);
                   NewAuction.HighBidder[75] = '\0';
              }
            break;
          case 5: //Number of bids
              if (NewAuction.BidCount[0]==0) {
                streamBuff.getline(LineData, 1024, '\n');
   for(cnt=0;(((LineData[cnt]!=' ') && (LineData[cnt]!=0)) && (cnt<14));++cnt)
                     NewAuction.BidCount[cnt]=LineData[cnt];
                   NewAuction.BidCount[cnt]=0;
              }
              break;
          case 6: //Location
              if (NewAuction.Location[0]==0) {
                streamBuff.getline(LineData, 1024, '\n');
                   strncpy(NewAuction.Location,LineData,100);
              }
            break;
          case 7: //Started
              if (NewAuction.Started[0]==0) {
                streamBuff.getline(LineData, 1024, '\n');
                   strncpy(NewAuction.Started,LineData,50);
                   translate_date( NewAuction.Started );
              }
            break;
	  case 11:
          case 8: //Ends
              if (NewAuction.Ends[0]==0) {
                streamBuff.getline(LineData, 1024, '\n');
                   strncpy(NewAuction.Ends,LineData,50);
                   translate_date( NewAuction.Ends ); 
              }
            break;
          default:;
            break;

    }
default:;
}
}
  }
  if ( NewAuction.CurrentBid[0] == 0 ) strcpy(NewAuction.CurrentBid, "Error");
      
  // now We'll parse the High Bidder and Seller's ratings off their names
  // and assign them to .SellerRate and .BidderRate
      
   strcpy ( newName, NewAuction.Seller);
   scratch = strtok(newName, "(");
   if ( !scratch ) return FALSE;
   strcpy( NewAuction.Seller, scratch);
   scratch = strtok(0,")");
      if (scratch) {
          strcpy(NewAuction.SellerRate, " (");
          strcat(NewAuction.SellerRate, scratch);
          strcat(NewAuction.SellerRate, ")");
      }
      
   if ((strcmp(NewAuction.HighBidder, "Dutch Auction") == 0) ||
       (strcmp(NewAuction.HighBidder, "see Dutch high bidders") == 0) ||
       (strcmp(NewAuction.HighBidder, "--") == 0 && ended_early == 0)) {
           return TRUE;
   } else {
      strcpy(newName, NewAuction.HighBidder);
      scratch = strtok(newName, "(");
  
      if (!scratch) return FALSE;
   
      strcpy(NewAuction.HighBidder, scratch);
      scratch = strtok(0,")");  
   
   if (ended_early == 1 && earlycheck ) {                // DBS
        if ( strcmp(NewAuction.Seller, authID) == 0) ended_early = 0;
        if ( strcmp(NewAuction.HighBidder, authID) != 0 && ended_early == 1) NewAuction.EndsValue = 0; // DBS
        }
          
       
      if (scratch) {
          strcpy(NewAuction.BidderRate, " (");
          strcat(NewAuction.BidderRate, scratch);
          strcat(NewAuction.BidderRate, ")");
      }
   } 

   return TRUE;
} // end GetAucInfo()
  
void MakeFileName(char * prefix1, char * prefix2, char * fileName, bool thisMonth)
{
   int month,year, err;
   time_t time_now = time(0);
   struct tm * timeStruct = localtime(&time_now);
   if ( thisMonth ) month = timeStruct->tm_mon + 1;
      else month = timeStruct->tm_mon;
   year = timeStruct->tm_year;
   if ( year > 99 ) year = year - 100;
   
   if ( year > 75 ) err = sprintf(fileName, "%s%s%d_%d.txt", prefix1, prefix2, month, year); 
   else err = sprintf(fileName, "%s%s%d_0%d.txt", prefix1, prefix2, month, year); 
}
void MakeClockTime(int offSet, char * theTime)
{
   time_t intTime = time(NULL) + offSet;
   char * tempTime = ctime(&intTime);
   char * scratch = strtok(tempTime, " ");
   if ( !scratch ) return;
   scratch = strtok(0, " ");
   if ( !scratch ) return;
   scratch = strtok(0, " ");
   if ( !scratch ) return;
   scratch = strtok(0, " ");
   if ( !scratch ) return;
   strcpy(theTime, scratch);
   return;
}
//////////////////////////////////////////////////////////////////////////////
// calcTimeDiff
//  
//  buffer is an unfiltered webpage from ebay containing the 
//  current time (http://cgi.ebay.com/aw-cgi/eBayISAPI.dll?TimeShow)
//
//  calcTimeDiff parses the time from the above mentioned page and 
//  calculates the difference between ebay time and local time, returning
//  the value in seconds.
//////////////////////////////////////////////////////////////////////////////
int calcTimeDiff ( char * buffer)
{  
   struct timeval time_tt;
   //time_t new_time_t = time(NULL);
   gettimeofday(&time_tt, 0);
   time_t new_time_t = time_tt.tv_sec;
   char chHr[9];
   char chMin[9];
   char chSec[9];
   char chYear[9];
   char chMonth[9];
   char chDay[9];
   char lineBuff[1024];
   char * scratch;
   istrstream streamBuff(buffer);
   struct tm ebay_time;
   ebay_time.tm_isdst = 0;
//   struct hostent * theAddress;
//struct hostent * host;
   while( streamBuff )
   {
      streamBuff.getline(lineBuff, 1024, '\n');

	scratch = strstr(lineBuff, "Monday");
	if (!scratch) scratch = strstr(lineBuff, "Tuesday");
	if (!scratch) scratch = strstr(lineBuff, "Wednesday");
	if (!scratch) scratch = strstr(lineBuff, "Thursday");
	if (!scratch) scratch = strstr(lineBuff, "Friday");
	if (!scratch) scratch = strstr(lineBuff, "Saturday");
	if (!scratch) scratch = strstr(lineBuff, "Sunday");

	if (scratch) {
	scratch = strtok(scratch, " ");
	if (scratch) scratch = strtok(0, " ");
	if (scratch) strcpy(chMonth, scratch);
	scratch = strtok(0, " ");
	if (scratch) strcpy(chDay, scratch);
	scratch = strtok(0, " ");
	if (scratch) strcpy(chYear, scratch);
	scratch = strtok(0,": ");
	if (scratch) strcpy(chHr, scratch);
	scratch = strtok(0,":");
	if (scratch) strcpy(chMin, scratch);
	scratch = strtok(0, " ");
	if (scratch) strcpy(chSec, scratch);
	scratch = strtok(0, "<");
	if (scratch && strcmp( scratch, "PDT" ) == 0 )
	 ebay_time.tm_isdst = 1;
	break;
	}
     }

   ebay_time.tm_hour = (((int(chHr[strlen(chHr) - 2])) - 48) * 10) +
                       ((int(chHr[strlen(chHr) - 1])) - 48);
   ebay_time.tm_min =  (((int(chMin[strlen(chMin) - 2])) - 48) * 10) +
                       ((int(chMin[strlen(chMin) - 1])) - 48);
   ebay_time.tm_sec =  (((int(chSec[strlen(chSec) - 2])) - 48) * 10) +
                       ((int(chSec[strlen(chSec) - 1])) - 48);
   ebay_time.tm_mday = atoi(chDay); 
   if ( strcmp("Jan", chMonth) == 0 ) ebay_time.tm_mon = 0 ;
   else if ( strcmp("Feb", chMonth) == 0 ) ebay_time.tm_mon = 1 ;
   else if ( strcmp("Mar", chMonth) == 0 ) ebay_time.tm_mon = 2 ;
   else if ( strcmp("Apr", chMonth) == 0 ) ebay_time.tm_mon = 3 ;
   else if ( strcmp("May", chMonth) == 0 ) ebay_time.tm_mon = 4 ;
   else if ( strcmp("Jun", chMonth) == 0 ) ebay_time.tm_mon = 5 ;
   else if ( strcmp("Jul", chMonth) == 0 ) ebay_time.tm_mon = 6 ;
   else if ( strcmp("Aug", chMonth) == 0 ) ebay_time.tm_mon = 7 ;
   else if ( strcmp("Sep", chMonth) == 0 ) ebay_time.tm_mon = 8 ;
   else if ( strcmp("Oct", chMonth) == 0 ) ebay_time.tm_mon = 9 ;
   else if ( strcmp("Nov", chMonth) == 0 ) ebay_time.tm_mon = 10 ;
   else ebay_time.tm_mon = 11;   
   ebay_time.tm_year = atoi(chYear) - 1900;  

   time_t theTime = mktime(&ebay_time) - new_time_t;

   return theTime;
}
//////////////////////////////////////////////////////////////////////////////
// parseRows
//   parses rows from raw html and puts them each on a line (if it
//   finds a newline character in a line it converts it to a space).
//////////////////////////////////////////////////////////////////////////////
void parseRows2(const char * fromBuff, char * toBuffer)
{
   char lineBuff[1025];
   strcpy(toBuffer,"");
   istrstream streamBuff(fromBuff);
   while( streamBuff )
  {
      streamBuff.getline(lineBuff, 1024, '\n');
	   
        if ( strstr(lineBuff,"item=") != NULL ) {
        streamBuff.getline(lineBuff, 1024, '\n');
        if ( strstr(lineBuff,"</a></td>") != NULL ) {
        lineBuff[10]='\0';
        strcat(toBuffer,lineBuff);
        strcat(toBuffer,"\n");
        }
         }   
          }
        }

void parseRows(const char * fromBuff, char * toBuffer)
{
   // we have 2 states: (1) we are inside a row or (2) we are not.
   // to determine we are in a row we need to find "<td>", to determine
   // we are out we need to find </td>.
   bool inRow = FALSE;
   int bufflen = strlen(fromBuff);
   int i,j;
   i = j = 0;
 bool inComment = false;
  for ( i=0; i<bufflen; i++)
   {
        /*
         * Let's first delete all of the JavaScript code by removing anything
         * that is an html comment.
         */
        
        if (inComment     == false &&
            fromBuff[i]   == '<' &&
            fromBuff[i+1] == '!' &&
            fromBuff[i+2] == '-' &&
            fromBuff[i+3] == '-')
        {
            i+=3;
            inComment = true;
        }
        else if (inComment     == true &&
                 fromBuff[i]   == '-' &&
                 fromBuff[i+1] == '-' &&
                 fromBuff[i+2] == '>')
        {
            i+=2;
            inComment = false;
        }
          
        // If we're inside an HTML comment, throw chars out.
        if (inComment == true) continue;
         
      if ((inRow==FALSE) &&
          (fromBuff[i] == '<') &&  
          (tolower(fromBuff[i + 1]) == 't') &&
          (tolower(fromBuff[i + 2]) == 'r'))
      {
         // we have found a cell and should start recording
         inRow = TRUE;
         toBuffer[j++] = fromBuff[i];  
      }   
      else if ((inRow==TRUE) && (fromBuff[i - 3] == '/') &&
               (tolower(fromBuff[i - 2]) == 't') &&
               (tolower(fromBuff[i - 1]) == 'r') &&
               (fromBuff[i] == '>'))
        {
          inRow = FALSE;
          toBuffer[j++] = fromBuff[i];
          toBuffer[j++] = '\n';
        }
      else if (inRow == TRUE) {
         // we will turn any newlines we find into spaces
         if ( fromBuff[i] == '\n' )
             toBuffer[j++] = ' ';
         else {
           // not fond of carriage returns; throw them out.
           while (fromBuff[i] == '\r')
             i++;
         
           toBuffer[j++] = fromBuff[i];
         }
      }
   }
   toBuffer[j] = '\0';
}
//////////////////////////////////////////////////////////////////////////////
// encode_password
//   converts the password to use the %## sequence so that special characters
//   in the password don't cause problems with the URL.  (It also makes the
//   password a little more hidden on the disk, but that is barely worth 
//   mentioning)
//////////////////////////////////////////////////////////////////////////////
void encode_password( char *dest, const char *src )
{
    int		i, j;

    *dest = '\0';

    for( i = 0, j = 0; src[ i ] != '\0'; i++ )
	j += sprintf( &dest[ j ], "%%%2X", src[ i ] );
}

void decode_password( char *dest, const char *src )
{
    int		i, j;
    int		c, t;

    *dest = '\0';

    for( i = 0, j = 0; src[ i ] != '\0'; i++, j++ )
    {
	if( src[ i ] == '%' )
	{
	    c = 0;

	    t = src[ i+1 ];
	    if( t >= '0' && t <= '9' )
		c += t - '0';
	    else if( t >= 'a' && t <= 'f' )
		c += t - 'a' + 10;
	    else if( t >= 'A' && t <= 'F' )
		c += t - 'A' + 10;
	    else
	    {
		dest[ j ] = src[ i ];
		continue;
	    }

	    c *= 16;

	    t = src[ i+2 ];
	    if( t >= '0' && t <= '9' )
		c += t - '0';
	    else if( t >= 'a' && t <= 'f' )
		c += t - 'a' + 10;
	    else if( t >= 'A' && t <= 'F' )
		c += t - 'A' + 10;
	    else
	    {
		dest[ j ] = src[ i ];
		continue;
	    }

	    dest[ j ] = c;
	    i += 2;
	}
	else
	    dest[ j ] = src[ i ];
    }

    dest[ j ] = '\0';
}
